require_relative '../Dbops'

module DailyRep
  module Entities


    class Doujob < IBrowser
      attr_reader  :diff
      include Dbops

      def self.create
          result = []
          result = Configer.get_search_strs('doujob').map { |str|
            new str
          }
      end

      def initialize search, source=Configer.doujob_source
        super
        @search=search.gsub(' ','+')
        @dou_search_path = source + @search
        @vacancy_scope = 'div#vacancyListId li'
        @parameter = 'title-href'
        @diff =[]
      end

      def log_msg phase
        super @entity, @search, phase
      end

      #overwriting
      def process
        super  do
          out_set = get_source_http @dou_search_path, @vacancy_scope
          @out_vac = out_set.map do |a|
            [a.css('.title .vt').attribute("href").text, "#{a.css('.company').text} : #{a.css('.title .vt').text}"]
          end
          out_hash = @out_vac.map { |el|
            {el[0] => el[1]}
          }
          hist_hash = read_hist_hash
          @diff = HashDiff.diff(out_hash, hist_hash)
        end
      end

      #overwriting
      def notify
        super do
          @diff.each { |lv1|
            push_note("New vacancy at DOU: #{lv1[2]} - #{lv1[3]} ") if lv1[0] == "-"
            push_note("DOU vacancy has gone: #{lv1[2]} - #{lv1[3]} ") if lv1[0] == "+"
          }
        end
      end
      #overwriting
      def write_to_db
        super do
          @out_vac.each { |vac|
            write_hist @entity, @parameter, "#{vac[0]}=>#{vac[1]}"
          }
        end
      end
      #overwriting
      def web_reload
        super do
          set_html_with_diff @entity, '#doujobs', @diff
        end
      end

      private
      def read_hist_hash
        maxtime = History.where(entity: @entity, parameter: @parameter).where("created_at > ?", Time.now - 6.hours).maximum("created_at")
        maxtime||= Time.now
        maxtime = maxtime.to_datetime
        History.select("val").where(entity: @entity, parameter: @parameter).where("created_at > ?", maxtime - 1.minute).map { |row|
          el_ar = row.val.split('=>')
          {el_ar[0] => el_ar[1]}
        }
      end

    end
  end
end
