#encoding: utf-8
require 'active_support/core_ext'
module DailyRep
  module Entities
    class Kinozal < IBrowser
      attr_reader :out_hash_clean, :to_notification

      def self.create
          result = []
          result = Configer.get_search_strs('kinozal').map { |str|
            new str
          }
      end

      def initialize  movie, source=Configer.kinozal_source, filters=Configer.kinozal_filters
        super
        @movie = movie
        @search_path = source+@movie.gsub(' ','+') + filters
        @scope = 'td.nam  a'
        @dirty_words = ['тизер', 'трейлер']
        @out_hash_clean = {}
      end

      def log_msg phase
        super @entity, @movie, phase
      end

      def process
        super do
          out_set = get_source_http @search_path, @scope
          out_hash_dirty = {}
          out_set.each { |el|
            out_hash_dirty.merge!({ el['href'] => el.text.split(' / ')})
          }
          out_hash_dirty.each { |key, val|
            exclude = 0
            @dirty_words.each { |word|
              if val[0].mb_chars.downcase.include?(word) then
                exclude = 1
                break
              end
            }
            @out_hash_clean.merge!({key => val}) if exclude == 0
          }
        end
      end

      def write_to_db
        super do
          @to_notification = {}
          @out_hash_clean.each { |key, val|
            id = key.split('id=')[1]
            if !check_row_exists(@entity, @movie, id) then
              write_hist(@entity, @movie, id, 1)
              @to_notification.merge!({key => [val[0], val.last]})
            end
          }
        end
      end

      def notify
        super do
          @to_notification.each { |key, val|
            note = "Kinozal
            Movie appears: #{val[0]}
            Quality: #{val.last}
            Link: #{key}"
            push_note note
          }
        end
      end


      def web_reload
        super do
          i = 0
          diff = @to_notification.map { |key, val|
            i = i+1
            ['-', i , {'http://kinozal.tv/'+ key => val.join(' : ')} ]
          }
          set_html_with_diff @entity, '#kinozal',  diff, true
        end
      end

    end
  end
end
