require_relative '../Changable'

module DailyRep
  module Entities
      class Micex < IBrowser
        include Changable
        attr_reader :values

        def self.create
          result = [(new)]
        end

        def initialize(delta=Configer.micex_delta, source=Configer.micex_source)
          @source      = source
          @notif_limit = delta
          @values      = {last: "", open: "", delta: "" }
          @push        = 0
          super
        end


        def log_msg phase
          super @entity, phase
        end

        def process
          super do
            result_json = get_source_json @source
            result_json = result_json[1]
            @last_val = result_json['LAST'].to_f
            @open_val = result_json['OPEN'].to_f
            @delta_prc_val = (((@last_val - @open_val)*100)/@open_val).round(2)
        #evaluate push 0 or 1 via Chgable module
        @push = track_change @delta_prc_val, @notif_limit
        #store values to write to db
        @values = { last: @last_val, open: @open_val, delta: @delta_prc_val }
        end
      end

      def notify
          super do
          if @push == 1 then
              note = "Micex USD/RUB
                              Last value: #{@last_val}
                              Open value: #{@open_val}
                              Delta percentage: #{@delta_prc_val}
                              www.googledrive.com/host/0Byb1mtPn4ZEAVm9zTUJQbHM2U0U"
              push_note note
          end
        end
      end

      def write_to_db
        super do
          write_hist @entity, :delta.to_s, @delta_prc_val, @push
        end
      end

      def web_reload
        super do
          set_html @entity, @values, @push
        end
      end
    end
  end
end
