require_relative  '../Changable'
module DailyRep
  module Entities
    class Minfin < IBrowser
      include Changable
      attr_reader :usd_uah_info

      def self.create
          result = [(new)]
      end

      def initialize( delta=Configer.minfin_delta, source=Configer.minfin_source)
        super
        @search_path   = source
        @notif_limit   = delta
        @usd_uah_info = {:buy_bank => -999, :sale_bank => -999}
        @push = 0
      end

      def log_msg phase
        super @entity, phase
      end

      def process
        super do

          out_set_bank = get_source_http @search_path, '.mb-data .per'
          @usd_uah_info[:buy_bank] = out_set_bank[0].text
          @usd_uah_info[:sale_bank] = out_set_bank[3].text


          @last_val = check_history_notif(@entity, :sale_bank.to_s, (Time.now - 1.week)).to_f
          cur =@usd_uah_info[:sale_bank].to_f
          @usd_uah_info[:delta] = (cur - @last_val)*100/cur

          @push = track_change @usd_uah_info[:delta], @notif_limit

        end
      end


      def notify
        super do
          if @push == 1 then
            note = "Minfin
        Current market: #{@usd_uah_info[:sale_bank]}
        Last value: #{@last_val}
        Delta percentage: #{@usd_uah_info[:delta]}"
            push_note note
          end
        end
      end


      def write_to_db
        super do
          write_hist @entity, :sale_bank.to_s, @usd_uah_info[:sale_bank], @push
          write_hist @entity, :delta.to_s, @usd_uah_info[:delta], @push
        end
      end

      def web_reload
        super do
          set_html @entity, {current: @usd_uah_info[:sale_bank], delta: @usd_uah_info[:delta]}
        end
      end
    end
  end
end
